/****************************************************************************/
/*                                                                          */
/*  PCSAPI.H -                                                              */
/*                                                                          */
/*      Include file for PCSAPI                                             */
/*                                                                          */
/****************************************************************************/

/*--------------------------------------------------------------------------*/
/*  General Purpose Definition                                              */
/*--------------------------------------------------------------------------*/

#define MAXPATHLEN                  100

/*--------------------------------------------------------------------------*/
/*  Definition for Query Session Status                                     */
/*--------------------------------------------------------------------------*/

#define SESSION_STARTED             0x0001
#define SESSION_ONLINE              0x0002
#define SESSION_API_ENABLED         0x0004

/*--------------------------------------------------------------------------*/
/*  Definition for Start Session                                            */
/*--------------------------------------------------------------------------*/

#define SS_SUCCESSFUL               0
#define SS_INVALID_ID               1
#define SS_USED_ID                  2
#define SS_INVALID_PROFILE          3
#define SS_SYSTEM_ERROR             9

/*--------------------------------------------------------------------------*/
/*  Definition for Stop Session                                             */
/*--------------------------------------------------------------------------*/

#define SS_SAVE_AS_PROFILE          0
#define SS_SAVE_ON_EXIT             1
#define SS_NOSAVE_ON_EXIT           2

/*--------------------------------------------------------------------------*/
/*  Function Prototypes                                                     */
/*--------------------------------------------------------------------------*/

WORD    FAR PASCAL pcsQueryEmulatorStatus(char);
BOOL    FAR PASCAL pcsQueryWorkstationProfile(char, LPSTR);
WORD    FAR PASCAL pcsStartSession(LPSTR, char, WORD);
BOOL    FAR PASCAL pcsStopSession(char, WORD);
