#******************************************************************************
#
# SPL2FILE - Make file for the SPL2FILE.EXE
#
#
#
#
#
#
#******************************************************************************

# This line allows NMAKE to work as well

all: spl2file.exe

#----------------------------------------------------------------
#  Name of MAKE file
#----------------------------------------------------------------
#
   MAKENAME = SPL2FILE.MAK
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
#
# Compiler options always in effect
#
# d   - show compiler passes
# FPi - emulator math
# c   - no link,
# u   - remove all predefined macros
# W2  - warning level
# AM  - medium model (FAR Code, NEAR Data references)
# Gs  - No stack check
# Gw  - Windows prolog/epilog
# NT  - Named code segment (name supplied)
#
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
# Compiler/Linker options when not debugging
#
# Ox    - maximum optimization
# Zp    - pack structures
# Ze    - Enable MS C code extensions
# MAP   - produce map (LINK)
# NOD   - no default library search (LINK)
# NOE   - no extended library search (LINK) n data on 16 byte boundary
# ALIGN - Align resource data on 16 byte boundary
#
  CFLAGSO = -Gsw -Ox -Zpe
  LFLAGSO = /MAP/NOD/NOE/ALIGN:16
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
# Compiler/Linker options when debugging
#
# Oa  - ignore aliasing
# Od  - disable optimization
# Zi  - debug information
# CO  - Produce CodeView EXE file
#
# CFLAGSD = -Gsw -Oad -Zipe -Fc   # Use this one if you want a .COD file!!
#
  CFLAGSD = -Gsw -Oad -Zipe
  LFLAGSD = /MAP/NOD/NOE/ALIGN:16/CO
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#

#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
#  1. MAKE MENUSTUB "IBMSTUB"
#
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#

ibmstub.obj: ibmstub.asm
   masm ibmstub.asm, ibmstub.obj, ibmstub.lst;

ibmstub.exe : ibmstub.obj
   link ibmstub.obj, ibmstub.exe, ibmstub.map;

#
#  1. Make spl2file Resource file
#

spl2file.res: spl2file.rc spl2file.h  spl2file.ico
    rc -r spl2file.rc

#
#  2. Make spl2file source file(s)
#

spwinman.obj: spwinman.c spl2file.h spdata.h
  cl -d -FPi -c -u -W2 -AM $(CFLAGSO) -NT_TEXT  spwinman.c

spspool.obj: spspool.c spl2file.h spdata.h spdde.h
  cl -d -FPi -c -u -W2 -AM $(CFLAGSO) -NTSPOOL  spspool.c

spconfg.obj: spconfg.c spl2file.h spdata.h
  cl -d -FPi -c -u -W2 -AM $(CFLAGSO) -NTSPOOL  spconfg.c

spsdde.obj:  spsdde.c  spl2file.h spdata.h spdde.h
  cl -d -FPi -c -u -W2 -AM $(CFLAGSO) -NT_TEXT  spsdde.c

spprsub.obj: spprsub.c spl2file.h spdata.h
  cl -d -FPi -c -u -W2 -AM $(CFLAGSO) -NTSPOOL  spprsub.c

spsub1.obj:  spsub1.c  spl2file.h spdata.h spdde.h
  cl -d -FPi -c -u -W2 -AM $(CFLAGSO) -NTSPOOL  spsub1.c

#
#  3. Make spl2file EXE file
#

spl2file.exe: spwinman.obj  spspool.obj   \
              spconfg.obj   spsdde.obj    \
              spprsub.obj   spsub1.obj    \
              spl2file.def  spl2file.res  ibmstub.exe
  link $(LFLAGSO) @spl2file.lnk
  rc -v spl2file.res
  command /c cvpack spl2file.exe
