//******************************************************************************
//
//  PROGRAM: spsdde.c
//
//  PURPOSE: 5250 Session DDE interface functions for Spl2File DDE application
//
//  FUNCTIONS:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//         Copyright (c) 1993, Yasuhide Niimura, IBM Corporation.
//
//                         All rights reserved.
//
//
//******************************************************************************

#define NOGDI
#define NOGDICAPMASKS
#define NOVIRTUALKEYCODES
#define NOSYSMETRICS
#define NOKEYSTATES
#define NOSYSCOMMANDS
#define NORASTEROPS
#define NOSHOWWINDOW
#define OEMRESOURCE
#define NOCOLOR
#define NOCTLMGR
#define NODRAWTEXT
#define NOMETAFILE
#define NOMINMAX
#define NOSOUND
#define NOTEXTMETRIC
#define NOCOMM
#define NOHELP
#define NOPROFILER
#define NODEFERWINDOWPOS

#include "windows.h"                // required for all Windows applications
#include "dde.h"                    // required for all Windows DDE Appls
#include <string.h>                 // C string functions
#include <stdio.h>                  // C functions
                                    //
#include "spl2file.h"               // specific to this program
#include "spdata.h"                 // Global Data
#include "spdde.h"                  // definitions of DDE data structures
                                    //
//******************************************************************************
//
// Local Data
//
//******************************************************************************

static uchar  zMenuServ[17];
static uchar  zMenuBar[17];
static uchar  zMenuMap[17];
static uchar  zABOUT[17];
static uchar  zSPOOL[17];
static uchar  zZCONFG[17];

static uchar *zMenuStruct =
{
"POPUP \"Sp&l2File\"\r\n\
BEGIN\r\n\
  MENUITEM \"Convert a &spool file\", SPOOL\r\n\
  MENUITEM SEPARATOR\r\n\
  MENUITEM \"&Config...\", ZCONFG\r\n\
  MENUITEM SEPARATOR\r\n\
  MENUITEM \"&About Spl2File...\", ABOUT\r\n\
END\r\n"
};

//******************************************************************************
//
//  InitDDE - Initialize various items needed for DDE
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

BOOL InitDDE( void )
{
  LoadString(hGlobalInst,  LS_16STR_FORMAT, zFmtBuffer, sizeof(zFmtBuffer));
  LoadString(hGlobalInst,  LS_DDE_TOKENS,   zMsgBuffer, sizeof(zMsgBuffer));

  sscanf( zMsgBuffer,                          // Input String
          zFmtBuffer,                          // sscanf format to use
          zMenuServ,                           // MenuServ
          zMenuBar,                            // MenuBar
          zMenuMap,                            // MenuMap
          zSPOOL,                              // SPOOL TO FILE
          zZCONFG,                             // CONFIGURE MYPRINT
          zABOUT   );                          // ABOUT
                                               //
  lstrcat(zMenuServ, zSessionID );             // Append Session ID

  return( TRUE );                              //
}                                              //

//******************************************************************************
//
//  SpDDEInitiate - Process the DDE_INITIATE message
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

BOOL FAR SpDDEInitiate(HWND hWnd, unsigned uMessage, WORD wParam, LONG lParam)
{                                                   //
                                                    //
  ATOM aApplication  = LOWORD( lParam );            //
  ATOM aTopic        = HIWORD( lParam );            //
                                                    //
  ATOM aMenuServ     = GlobalAddAtom( (LPSTR)zMenuServ );  // Register Atoms
  ATOM aMenuBar      = GlobalAddAtom( (LPSTR)zMenuBar  );  //
  ATOM aSPOOL        = GlobalAddAtom( (LPSTR)zSPOOL    );  //
  ATOM aZCONFG       = GlobalAddAtom( (LPSTR)zZCONFG   );  //
  ATOM aABOUT        = GlobalAddAtom( (LPSTR)zABOUT    );  //

  BOOL bRC           = FALSE;                       //

  if( aApplication == aMenuServ )                   //
  {                                                 //
    if( aTopic == aMenuBar )                        // Setup a menu bar?
    {                                               // Yes,
      {                                             //
        hDDEClientWnd  = wParam;                    // Save away client window handle
        bRC            = TRUE;                      // Signal success
        if( !SendMessage(wParam, WM_DDE_ACK, hWnd, MAKELONG( aApplication, aTopic )) )
        {                                           //
          GlobalDeleteAtom( aApplication );         // Error, delete client's ATOMS
          GlobalDeleteAtom( aTopic    );            // Error, delete client's ATOMS
        }                                           //
      }                                             //
    }                                               //
    else if( aTopic == aSPOOL || aTopic == aZCONFG  //
             || aTopic == aABOUT )                  //
    {                                               //
      HWND         hSessionWnd;                     //
      WORD         uCMD;                            //
      bRC        = TRUE;                            // Signal success
      hDDEClientWnd  = wParam;                      // Save away client window handle
      if( !SendMessage(wParam, WM_DDE_ACK, hWnd, MAKELONG( aApplication, aTopic )) )
      {                                             //
        GlobalDeleteAtom( aApplication );           // Error, delete client's ATOMS
        GlobalDeleteAtom( aTopic    );              // Error, delete client's ATOMS
      }                                             //
      if( aTopic == aSPOOL )                        // w߰ق̧قɕϊ(&S)x
      {                                             //
        uCMD = ID_SPOOL;                            //
      }                                             //
      else if( aTopic == aZCONFG )                  // wݒ(&C)x
      {                                             //
        uCMD = ID_ZCONFG;                           //
      }                                             //
      else if( aTopic == aABOUT )                   // wSpl2File ɂ(&A)...x
      {                                             //
        uCMD = ID_ABOUT2;                           //
      }                                             //
      hSessionWnd = FindWindow((LPSTR) zSessionClassName, (LPSTR) NULL);
      PostMessage(hWnd, WM_COMMAND, uCMD, MAKELONG( wParam, hSessionWnd) );
    }                                               //
  }                                                 //

  GlobalDeleteAtom( aMenuServ );                    // Delete Atoms
  GlobalDeleteAtom( aMenuBar  );                    //
  GlobalDeleteAtom( aSPOOL    );                    //
  GlobalDeleteAtom( aZCONFG   );                    //
  GlobalDeleteAtom( aABOUT    );                    //

  return( bRC );                                    //
}                                                   //

//******************************************************************************
//
//  SpDDEAck - Process the DDE_ACK message
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

BOOL FAR SpDDEAck(HWND hWnd, unsigned uMessage, WORD wParam, LONG lParam)
{                                                   //
  BYTE Event;                                       //
  BOOL bRC           = FALSE;                       // Error until proven otheriwse ...

  if ((LOWORD(lParam) == aIBM5250) &&               // Check Application and
      (HIWORD(lParam) == aSession))                 //  topic name
  {                                                 //
    hSessWnd = wParam;                              // Ack of WM_DDE_INITIATE
    bRC = TRUE;                                     //
  }                                                 //
  else if (wParam == hSessWnd)                      // Ack of other messages
  {                                                 //
    if (LOWORD(lParam) == DDE_ACK)                  // O.K.
    {                                               //
      Event = EV_ACK;                               //
    }                                               //
    else                                            // N.G.
    {                                               //
      Event = EV_NACK;                              //
    }                                               //

    if (uLastMessage == WM_DDE_EXECUTE)             // process next step
    {                                               //
      bRC = FSM_Event( Event, NULL, HIWORD(lParam) );   //
    }                                               //
    else                                            //
    {                                               //
      bRC = FSM_Event( Event, HIWORD(lParam), NULL );   //
    }                                               //
  }                                                 //
  return( bRC  );                                   //
}                                                   //

//******************************************************************************
//
//  SpDDEData - Process the DDE_DATA message
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

BOOL FAR SpDDEData(HWND hWnd, unsigned uMessage, WORD wParam, LONG lParam)
{                                                   //
  BOOL bRC           = FALSE;                       // Error until proven otheriwse ...

  if (wParam == hSessWnd)                           //
  {                                                 //
    bRC = FSM_Event( EV_DATA, HIWORD(lParam), LOWORD(lParam) );
  }                                                 // process the next step
  return( bRC  );                                   //
}                                                   //

//******************************************************************************
//
//  SpDDERequest - Process the DDE_REQUEST message
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

BOOL FAR SpDDERequest(HWND hWnd, unsigned uMessage, WORD wParam, LONG lParam)
{
  ATOM aMenuMap = GlobalAddAtom( zMenuMap );     // Holder Atom
  ATOM aItem    = HIWORD( lParam );              // Requested aItem
  int  cfFormat = LOWORD( lParam );              // Requested Format
  BOOL bRC      = FALSE;                         // Error until proven otheriwse ...
  DDEDATA FAR *   lpData;                        // Long Pointer to DATA structure
  HANDLE          hData;                         // Handle       to DATA structure
  DWORD           dwSize = (sizeof(DDEDATA) + strlen(zMenuStruct) + 16);

  if( (aItem == aMenuMap) && (cfFormat == CF_TEXT) )
  {                                              //
    if( (hData = GlobalAlloc(DDE_GLOBAL, dwSize)) != NULL )
    {                                            //
      if( (lpData = (DDEDATA FAR *) GlobalLock(hData)) != NULL ) //
      {                                          //
        lpData->cfFormat = cfFormat;             // Format
        lpData->fAckReq  = FALSE;                // No return ACK
        lpData->fRelease = TRUE;                 // Client GlobalFree this buffer
        lstrcpy(lpData->Value, zMenuStruct);     // Data
        GlobalUnlock(hData);                     // Unlock the buffer
        aItem = GlobalAddAtom( zMenuMap );       // Add item for call
        if( !PostMessage(wParam, WM_DDE_DATA, hWnd, MAKELONG(hData, aItem)) )
        {                                        //
          GlobalDeleteAtom( aItem  );            // Delete the item
          GlobalFree(hData);                     // and free the data
          TerminateConversation();               //
        }                                        //
        else                                     //
        {                                        //
          bRC = TRUE;                            // Success!
        }                                        //
      }                                          //
      else                                       // Couldn't lock it ...
      {                                          //
        GlobalFree(hData);                       // So free it .....
      }                                          //
    }                                            //
  }                                              //
  GlobalDeleteAtom( aMenuMap );                  // Delete the holder atom
  return( bRC  );                                // return bRC
}                                                //

//******************************************************************************
//
//  SpDDETerminate - Process the DDE_TERMINATE message
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

BOOL FAR SpDDETerminate(HWND hWnd, unsigned uMessage, WORD wParam, LONG lParam)
{                                                //
  if (wParam == hSessWnd)                        //
  {                                              //
    hSessWnd = NULL;                             //
  }                                              //
  else                                           //
  {                                              //
    if( hDDEClientWnd != NULL )                  // Is client alive?
    {                                            // Terminate him
      TerminateConversation();                   //
    }                                            //
  }                                              //

  return( TRUE );                                // return success
}                                                //

//******************************************************************************
//
//  PrepGetPartialPs - Issues "Set Prsentation Space Service Condition".
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

void PrepGetPartialPs(int nRow, int nCol, int nLength)
{                                                //
  HANDLE            hData;                       //
  LPDDE_PSCOND      lpPsCond;                    //

  hData = GlobalAlloc(WC_DDE_GLOBAL, (DWORD)(sizeof(DDE_PSCOND)));
  if (hData)                                     // allocate message buffer
  {                                              //
    lpPsCond = (LPDDE_PSCOND)GlobalLock(hData);  //
    if (HIWORD(lpPsCond) != NULL)                //
    {                                            //
      lpPsCond->DDEpoke.fRelease            = TRUE;                    //
      lpPsCond->DDEpoke.cfFormat            = CF_DSPTEXT;              // format
      lpPsCond->DDEPsCond.uPSStart          = (nRow-1) * 80 + (nCol-1);// PS position
      lpPsCond->DDEPsCond.uPSLength         = nLength;                 // Length
      lpPsCond->DDEPsCond.szTargetString[0] = NULL;                    //
      GlobalUnlock(hData);                       //
      if (hSessWnd)                              //
      {                                          //
        PostMessage(hSessWnd,                    // Post message to DDE server
                    WM_DDE_POKE,                 //  (PC/5250)
                    hMainWnd,                    //
                    MAKELONG(hData, aEPSCOND));  //
        uLastMessage = WM_DDE_POKE;              //
      }                                          //
      else                                       //
      {                                          //
        GlobalFree(hData);                       //
      }                                          //
    }                                            //
    else                                         //
    {                                            //
      GlobalFree(hData);                         //
    }                                            //
  }                                              //
}                                                //

//******************************************************************************
//
//  RequestGetPs - Issues "Get Prsentation Space" (CF_DSPTEXT).
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

void  RequestGetPs( void )                       //
{                                                //
  if (hSessWnd)                                  //
  {                                              //
    PostMessage(hSessWnd,                        //
                WM_DDE_REQUEST,                  //
                hMainWnd,                        //
                MAKELONG(CF_DSPTEXT, aPS));      //
    uLastMessage = WM_DDE_REQUEST;               //
  }                                              //
}                                                //

//******************************************************************************
//
//  RequestGetPartPs - Issues "Get Partial Prsentation Space" (CF_TEXT).
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

void  RequestGetPartPs( void )                   //
{                                                //
  if (hSessWnd)                                  //
  {                                              //
    PostMessage(hSessWnd,                        //
                WM_DDE_REQUEST,                  //
                hMainWnd,                        //
                MAKELONG(CF_DSPTEXT, aEPS));     //
    uLastMessage = WM_DDE_REQUEST;               //
  }                                              //
}                                                //

//******************************************************************************
//
//  ExecuteKeystrokes - Issues "Session Execute Macro" SENDKEY command
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

void  ExecuteKeystrokes( LPSTR lpKeys )          //
{                                                //
  HANDLE   hData;                                //
  LPSTR    lpData;                               //
  BOOL     bRequest = FALSE;                     //

  hData = GlobalAlloc(WC_DDE_GLOBAL, (DWORD)256 );  //
  if (hData)                                     //
  {                                              //
    lpData = GlobalLock(hData);                  //
    if (HIWORD(lpData) != NULL)                  //
    {                                            //
      lstrcpy(lpData, "[SENDKEY(");              // command name
      lstrcat(lpData, "wait inp inh");           // wait while input inhibit
      lstrcat(lpData, ",");                      //
      lstrcat(lpData, lpKeys);                   //
      lstrcat(lpData, ",");                      //
      lstrcat(lpData, "wait inp inh");           // wait while input inhibit
      lstrcat(lpData, ")]");                     //
      GlobalUnlock(hData);                       //

      if (hSessWnd)                              //
      {                                          //
        PostMessage(hSessWnd,                    // post to PC/5250
                    WM_DDE_EXECUTE,              //
                    hMainWnd,                    //
                    MAKELONG(NULL, hData));      //
        uLastMessage = WM_DDE_EXECUTE;           //
        bRequest = TRUE;                         //
      }                                          //
    }                                            //
    else                                         //
    {                                            //
      GlobalFree(hData);                         //
    }                                            //
  }                                              //
  if (!bRequest)                                 //
  {                                              //
    PostMessage(hMainWnd,                        //
                WM_USER_ERROR,                   //
                hMainWnd,                        //
                MAKELONG(NULL, NULL) );          //
  }                                              //
}                                                //

//******************************************************************************
//
//  SetCursorPosition - Issues "Set Cursor Position".
//
//  PURPOSE:
//
//
//  COMMENTS:
//
//
//  Change History:
//
//  04/02/93  Creation                                  Yasuhide Niimura
//
//
//******************************************************************************

void SetCursorPosition(int nRow, int nCol)
{                                                //
  HANDLE            hData;                       //
  LPDDE_CURSOR      lpCursor;                    //

  hData = GlobalAlloc(WC_DDE_GLOBAL, (DWORD)(sizeof(DDE_CURSOR)));  //
  if (hData)                                     //
  {                                              //
    lpCursor = (LPDDE_CURSOR)GlobalLock(hData);  //
    if (HIWORD(lpCursor) != NULL)                //
    {                                            //
      lpCursor->DDEpoke.fRelease              = TRUE;       //
      lpCursor->DDEpoke.cfFormat              = CF_DSPTEXT; //
      lpCursor->DDESetCursor.uCursorSetType   = 1;          // Row/Col option
      lpCursor->DDESetCursor.uCursorSetValue1 = nRow-1;     // Row number
      lpCursor->DDESetCursor.uCursorSetValue2 = nCol-1;     // Column number
      GlobalUnlock(hData);                       //
      if (hSessWnd)                              //
      {                                          //
        PostMessage(hSessWnd,                    //
                    WM_DDE_POKE,                 //
                    hMainWnd,                    //
                    MAKELONG(hData, aSETCURSOR));//
        uLastMessage = WM_DDE_POKE;              //
      }                                          //
      else                                       //
      {                                          //
        GlobalFree(hData);                       //
      }                                          //
    }                                            //
    else                                         //
    {                                            //
      GlobalFree(hData);                         //
    }                                            //
  }                                              //
}                                                //
